﻿-- Version & Date
local MAJOR_VERSION = "1.3.2"
local MINOR_VERSION = tonumber((string.gsub("$Revision: 48 $", "^.-(%d+).-$", "%1")))

CleanShot = LibStub("AceAddon-3.0"):NewAddon("CleanShot", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("CleanShot")

-- Keybindings
BINDING_HEADER_CLEANSHOT = "CleanShot"
BINDING_NAME_CLEAN_SCREENSHOT = L["clean"]

-- About
local CleanShot = CleanShot
CleanShot.title = "CleanShot"
CleanShot.version = MAJOR_VERSION .. "." .. MINOR_VERSION
CleanShot.date = string.gsub("$Date: 2009-05-09 08:30:12 +0000 (Sat, 09 May 2009) $", "^.-(%d%d%d%d%-%d%d%-%d%d).-$", "%1")

-- Inititalize
	function CleanShot:OnInitialize()
		local defaults = {
			profile = {
				own = false,
				npc = false,
				guild = false,
				pvp = false,
				companion = false,
				fPlayer = false,
				fPet = false,
				fCreation = false,
				ePlayer = false,
				ePet = false,
				eCreation = false,
                screenNumber = 1,
			}
		}
		local options = {
			type="group",
			args = {
--~                 screenNumber = {
--~ 					name = 	L["number"], 
--~ 					type = 	"range",
--~ 					desc = 	string.format(L["screen"],L["own"]),
--~                     min = 1,
--~                     max = 10,
--~                     step = 1,
--~ 					get = 	function() return self.db.profile.screenNumber end,
--~ 					set = 	function(i,v) self.db.profile.screenNumber = v end,
--~ 					width="full",
--~ 					order=0,
--~                 },
				desc = {
					type = "description",
					name = L["optionDesc"],
					order = 1,
				},
				general = {
					name=L["general"],
					type="group",
					inline=true,
					order=2,
					args = {
						own = {
							name = 	L["own"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["own"]),
							get = 	function() return self.db.profile.own end,
							set = 	function(i,v) self.db.profile.own = v end,
							width="full",
							order=1,
						},
						npc = {
							name = 	L["npc"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["npc"]),
							get = 	function() return self.db.profile.npc end,
							set = 	function(i,v) self.db.profile.npc = v end,
							width="full",
							order=2,
						},
						pvp = {
							name = 	L["pvp"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["pvp"]),
							get = 	function() return self.db.profile.pvp end,
							set = 	function(i,v) self.db.profile.pvp = v end,
							width="full",
							order=3,
						},
						guild = {
							name = 	L["guild"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["guild"]),
							get = 	function() return self.db.profile.guild end,
							set = 	function(i,v) self.db.profile.guild = v end,
							width="full",
							order=4,
						},
						companion = {
							name = 	L["companion"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["companion"]),
							get = 	function() return self.db.profile.companion end,
							set = 	function(i,v) self.db.profile.companion = v end,
							width="full",
							order=5,
						},
					}
				},
				friendly = {
					name=L["friendly"],
					type="group",
					inline=true,
					order=3,
					args = {
						fPlayer = {
							name = 	L["fPlayer"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["fPlayer"]),
							get = 	function() return self.db.profile.fPlayer end,
							set = 	function(i,v) self.db.profile.fPlayer = v end,
							width="full",
							order=1,
						},
						fPet = {
							name = 	L["fPet"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["fPet"]),
							get = 	function() return self.db.profile.fPet end,
							set = 	function(i,v) self.db.profile.fPet = v end,
							width="full",
							order=2,
						},
						fCreation = {
							name = 	L["fCreation"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["eCreation"]),
							get = 	function() return self.db.profile.fCreation end,
							set = 	function(i,v) self.db.profile.fCreation = v end,
							width="full",
							order=3,
						},
					}
				},
				enemy = {
					name=L["enemy"],
					type="group",
					inline=true,
					order=4,
					args = {
						ePlayer = {
							name = 	L["ePlayer"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["ePlayer"]),
							get = 	function() return self.db.profile.ePlayer end,
							set = 	function(i,v) self.db.profile.ePlayer = v end,
							width="full",
							order=1,
						},
						ePet = {
							name = 	L["ePet"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["ePet"]),
							get = 	function() return self.db.profile.ePet end,
							set = 	function(i,v) self.db.profile.ePet = v end,
							width="full",
							order=2,
						},
						eCreation = {
							name = 	L["eCreation"], 
							type = 	"toggle",
							desc = 	string.format(L["screen"],L["eCreation"]),
							get = 	function() return self.db.profile.eCreation end,
							set = 	function(i,v) self.db.profile.eCreation = v end,
							width="full",
							order=3,
						},
					}
				}
			}
		}
		self.db = LibStub("AceDB-3.0"):New("CleanShotDB", defaults, "Default")
		LibStub("AceConfig-3.0"):RegisterOptionsTable("CleanShot", options)
		self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CleanShot", "CleanShot")
		self:RegisterChatCommand("CleanShot", "ChatCommand")
        
--~         Initialisation de variables temporaires
        self.tempScreening = false
	end

-- OnEnable	
	function CleanShot:OnEnable()
		self:RegisterEvent("SCREENSHOT_FAILED")
		self:RegisterEvent("SCREENSHOT_SUCCEEDED")
	end

-- OnDisable	
	function CleanShot:OnDisable()
	end
	
-- ChatCommand
	function CleanShot:ChatCommand(input)
		if not input or input:trim() == "" then
			InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
		else
			LibStub("AceConfigCmd-3.0").HandleCommand(CleanShot, "CleanShot", input)
		end
	end

-- Events
	function CleanShot:SCREENSHOT_FAILED()
		if self.tempScreening then self:StopScreening() end
	end
	function CleanShot:SCREENSHOT_SUCCEEDED()
		if self.tempScreening then self:StopScreening() end
	end
    
-- Screenshot functions	
	function CleanShot:StartScreening()
        if self.tempScreening == false then
            self.tempScreening = true
            self.tempScreenNumber = 0
            self.tempOwn = GetCVar("UnitNameOwn")
            self.tempNpc = GetCVar("UnitNameNPC")
            self.tempGuild = GetCVar("UnitNamePlayerGuild")
            self.tempPvp = GetCVar("UnitNamePlayerPVPTitle")
            self.tempCompanion = GetCVar("UnitNameCompanionName")
            self.tempFPlayer = GetCVar("UnitNameFriendlyPlayerName")
            self.tempFPet = GetCVar("UnitNameFriendlyPetName")
            self.tempFCreation = GetCVar("UnitNameFriendlyCreationName")
            self.tempEPlayer = GetCVar("UnitNameEnemyPlayerName")
            self.tempEPet = GetCVar("UnitNameEnemyPetName")
            self.tempECreation = GetCVar("UnitNameEnemyCreationName")
            self.tempUIParent = UIParent:IsVisible()
            if self.db.profile.own then SetCVar("UnitNameOwn", 1) else SetCVar("UnitNameOwn", 0) end
            if self.db.profile.npc then SetCVar("UnitNameNPC", 1) else SetCVar("UnitNameNPC", 0) end
            if self.db.profile.guild then SetCVar("UnitNamePlayerGuild", 1) else SetCVar("UnitNamePlayerGuild", 0) end
            if self.db.profile.pvp then SetCVar("UnitNamePlayerPVPTitle", 1) else SetCVar("UnitNamePlayerPVPTitle", 0) end
            if self.db.profile.companion then SetCVar("UnitNameCompanionName", 1) else SetCVar("UnitNameCompanionName", 0) end
            if self.db.profile.fPlayer then SetCVar("UnitNameFriendlyPlayerName", 1) else SetCVar("UnitNameFriendlyPlayerName", 0) end
            if self.db.profile.fPet then SetCVar("UnitNameFriendlyPetName", 1) else SetCVar("UnitNameFriendlyPetName", 0) end
            if self.db.profile.fCreation then SetCVar("UnitNameFriendlyCreationName", 1) else SetCVar("UnitNameFriendlyCreationName", 0) end
            if self.db.profile.ePlayer then SetCVar("UnitNameEnemyPlayerName", 1) else SetCVar("UnitNameEnemyPlayerName", 0) end
            if self.db.profile.ePet then SetCVar("UnitNameEnemyPetName", 1) else SetCVar("UnitNameEnemyPetName", 0) end
            if self.db.profile.eCreation then SetCVar("UnitNameEnemyCreationName", 1) else SetCVar("UnitNameEnemyCreationName", 0) end
            if self.tempUIParent then RunBinding("TOGGLEUI") end
            TakeScreenshot()
        end
	end
  
	function CleanShot:StopScreening()
--~         self.tempScreenNumber = self.tempScreenNumber + 1
--~         if self.tempScreenNumber == self.db.profile.screenNumber then        
            SetCVar("UnitNameOwn", self.tempOwn)
            SetCVar("UnitNameNPC", self.tempNpc)
            SetCVar("UnitNamePlayerGuild", self.tempGuild)
            SetCVar("UnitNamePlayerPVPTitle", self.tempPvp)
            SetCVar("UnitNameCompanionName", self.tempCompanion)
            SetCVar("UnitNameFriendlyPlayerName", self.tempFPlayer)
            SetCVar("UnitNameFriendlyPetName", self.tempFPet)
            SetCVar("UnitNameFriendlyCreationName", self.tempFCreation)
            SetCVar("UnitNameEnemyPlayerName", self.tempEPlayer)
            SetCVar("UnitNameEnemyPetName", self.tempEPet)
            SetCVar("UnitNameEnemyCreationName", self.tempECreation)
            if self.tempUIParent then RunBinding("TOGGLEUI") end
            self.tempScreening = false
--~         else
--~             TakeScreenshot()
--~         end
    end
	
-- The End